# AI_AUTO_PLAY_MOD
#
# version 1.0a

from CvPythonExtensions import *
import CvUtil

gc = CyGlobalContext()
game = CyGame()

import PyCivSim

HOTKEY_AUTO = "Control-Shift-X"

#-------------------------------------------------------------------------
# Event handlers
def EventHandlerRegister(evt_mgr, unused = None):
	CvUtil.pyPrint( __name__ + ": Event handler register OK." )
	
	AILogs = AILogger()
	
	return  { 
			"victory"  		: 	AILogs.onVictory,	
			"kbdEvent" 		:	AILogs.onKbdEvent,
			}
			
HOTKEY_AUTO = PyCivSim.getHotkey("AI_TESTER_MOD", "RUNTEST", HOTKEY_AUTO)

class AILogger:
	def __init__(self) :
		self.TurnsToAuto = 9999

	def onKbdEvent( self, argsList ) :
		'keypress handler'
#	   eventType,key,mx,my,px,py = argsList
#		( isKeyDownEvent, theKey, mx, my, px, py, 
#			( keyModifier, bShift, bCtrl, bAlt), Unused ) = argsList

		if PyCivSim.checkKeyInput( argsList, HOTKEY_AUTO ) :
			if( game.getAIAutoPlay() > 0 ) :
				self.TurnsToAuto = 0
				self.setAIAutoPlay()
			else :
				# Random big number
				self.TurnsToAuto = 9999
				self.setAIAutoPlay()
			return 1
			
	
	def onVictory(self, argsList):

		self.newGame()
			
	def addLineToLoopList(self, nextLine, j, newLineList, lineStr):
		try:
			newLineList[nextLine + j] += lineStr		
		except IndexError:
			newLineList.append("")
			self.addLineToLoopList(nextLine, j, newLineList, lineStr)
			
	def newGame(self) :
		global game		
		iWorldSize = 0 # Doesn't matter - is set inside the function. Currently not supported
		iClimate = CyMap().getClimate()
		iSeaLevel = CyMap().getSeaLevel()
		iGameSpeed = game.getGameSpeedType()
		iNumPlayers = game.countCivPlayersEverAlive()
		paiCivilizations = self.getRandomCivs(iNumPlayers)
		
		paiLeaderHeads = []
		for iCiv in paiCivilizations:
			civLeaderList = []
			for i in range(gc.getNumLeaderHeadInfos()):
				if gc.getCivilizationInfo(iCiv).isLeaders(i):
					civLeaderList.append(i)
			paiLeaderHeads.append(civLeaderList[game.getSorenRandNum(len(civLeaderList), "randomLeaderheads")])
		
		paiTeams = []
		for i in range(iNumPlayers):
			if i != gc.getBARBARIAN_TEAM():
				paiTeams.append(i)
		
		if ( game.getAIAutoPlay( ) > 0 ) :
			game.newGame(iWorldSize, iClimate, iSeaLevel, iGameSpeed, paiCivilizations, paiLeaderHeads, paiTeams)
			game = CyGame()	
			# Big number - want to auto untill end of the game
			self.TurnsToAuto = 9999
			self.setAIAutoPlay()
		#else:
		#	game.newGame(iWorldSize, iClimate, iSeaLevel, iGameSpeed, paiCivilizations, paiLeaderHeads, paiTeams)
		#	game = CyGame()
		

	def setAIAutoPlay( self ) :
		game.setAIAutoPlay( self.TurnsToAuto )
		
	
	def getRandomCivs(self, iNumCivs):
		randCivList = []
			
		while len(randCivList) < iNumCivs:
			rand = game.getSorenRandNum(gc.getNumCivilizationInfos(), "randomCiv")
			
			if gc.getCivilizationInfo(rand).isAIPlayable():
				if rand not in randCivList:
					randCivList.append(rand)
			
		return randCivList
			
