## GeneticAI Specialized Python Functions

import genAIEvents
from genAIData import *

from CvPythonExtensions import *

gc = CyGlobalContext()

defaultData = [getDefaultCityData(), getDefaultGameData(), getDefaultPlayerData(),
	getDefaultSelectionData(), getDefaultTeamData(), getDefaultUnitData(), getNumCityBools() * [0],
	getNumGameBools() * [0], getNumPlayerBools() * [0], getNumSelectionBools() * [0], getNumTeamBools() * [0],
	getNumUnitBools() * [0]]
				
def setNumPlayers(argsList):
	iNumPlayers = argsList[0]
	
	genAIEvents.setNumPlayers(iNumPlayers)

def getAIData(argsList):
	iPlayer, eLeader, iAI, key = argsList
		
	if genAIEvents.getGameAIList() == []:
		genAIEvents.generateGameAIs()
		
	if len(genAIEvents.gameAIList) <= iPlayer:
		genAIEvents.matchAIToLeader(eLeader)
			
	try:
		return genAIEvents.gameAIList[iPlayer].getAIData()[iAI][key]
	except IndexError:
		return -1
			
def getDefaultAIData(argsList):
	iAI, key = argsList
	try:
		return defaultData[iAI][key]
	except IndexError:
		return -1		
		
def setAIName(argsList):
	iPlayer = argsList[0]
	
	if iPlayer < len(genAIEvents.getGameAIList()):
		gc.getPlayer(iPlayer).setName(genAIEvents.getGameAIList()[iPlayer].getAIName())