############### ADDED BY SIMCUTIE #########################################
# $Source: /cvsroot/civ4geneticai/Assets/Python/Screens/CvSimCutieMainInterface.py,v $: $Name:  $
#	SimCutie's Civ4 Main Interface enhancement add-on
#	$CopyRight$
#	by SimCutie < simcutie (AT) hanmail.net >
#	Based on Civ4 Update 1.61
#	V 0.1 show diplomatic attitude, Simple game clock, unit name and GP localization
#	V 0.2 custom options and attitude color/text configurablity
#		Clock bug fix when Time Victory condition is off
#	V 0.3 revised for Update 1.52, Added 12Monkys's Plot Line Enhancement.
#	V 0.5 first Offical Release
#	V 0.6 subclassed, extended CityScreenAdjustPanel, Citizen buttons
#	V 0.9 Based on Civ4 Update 1.61
#	V 1.0 Compatible to 1st Release of Civ4CCP SDK DLL.
#	This file should reside in  "... /CustomAssets/python/screens" folder.
#	Version: $Revision: 1.1 $ $Date: 2006/09/12 12:43:11 $
#
__author__ = "$Author: the_great_apple $"
__revision__ = "$Id: CvSimCutieMainInterface.py,v 1.1 2006/09/12 12:43:11 the_great_apple Exp $"
__version__ = "$Revision: 1.1 $"
__date__ = "$Date: 2006/09/12 12:43:11 $"

#-------------------------------------------------------------------------
# USER CONFIGURATION OPTION
CONFIG_USE_CENTERUNIT = True
SHOW_ATT_DEF = 0		# Attitude_None
#-------------------------------------------------------------------------
from PyCivSim import ( getCustomOption, setCustomOption, useOptionSection,
			MSGDEBUG, getExtGC, hasExtGC )
import PyCivSim
from PyExtLib import qPrint, simpleConstValue
from PyBaseLib import qbound
#from ActionButton import AButton, ActionButtons

import CvMainInterface

## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
from CvPythonExtensions import *
import CvUtil
import CvScreenEnums
import time

# globals
from CvMainInterface import ( gc, ArtFileMgr, localText )

from CvMainInterface import MAX_CITIZEN_BUTTONS, SELECTION_BUTTON_COLUMNS
MAX_CITIZEN_BUTTONS = 6 * 2 -1
CITIZEN_BUTTON_OFFSET = 34 / 2
CITIZEN_BUTTON_BASE = 248
CITYADJPANNEL_ENXTEND = 60			# extend CityScreenAdjustPanel by this height.
CITYADJPANNEL_TEXT_LINES = 4		# and how many text lines total

# MINIMAP BUTTON POSITIONS
from CvMainInterface import iMinimapButtonsY_Regular, iMinimapButtonsY_Minimal
# Globe button
from CvMainInterface import iGlobeButtonY_Regular, iGlobeButtonY_Minimal
# MULTI LIST
from CvMainInterface import iMultiListXL, iMultiListXR

from CvMainInterface import g_pSelectedUnit, g_NumUnitClassInfos, g_NumBuildingClassInfos
from CvMainInterface import	g_NumEmphasizeInfos, g_NumCityTabTypes, g_NumHurryInfos
from CvMainInterface import g_NumProjectInfos, g_NumProcessInfos, g_NumActionInfos

def EventHandlerRegister( evt_mgr, unused = None ):
	import CvCustomEvent, PyCivSim
	mainInterface = CvSimCutieMainInterface()
	# replace original CvMainInterface instance
	PyCivSim.ScreenRegister( mainInterface, CvScreenEnums.MAIN_INTERFACE )
	qPrint(__name__, "MainInterfaceScreen Register OK.")
	
	eventDict = { "UnInit-" : mainInterface.onUnInit,
		CvCustomEvent.EVENT_OPTIONBEGIN: onDrawOption,
		CvCustomEvent.EVENT_OPTIONEND: mainInterface.onCloseOption,
	}
	if CONFIG_USE_CENTERUNIT :
		eventDict.update( {	CvCustomEvent.EVENT_BUTTONSHOW: onShowButton,
							CvCustomEvent.EVENT_BUTTONACTION: onActionButton } )

	return eventDict

def onDrawOption(argsList):
	optscr, canvas, Unused = argsList[:3]
	#------------------------------------------------------------------
	# Show Diplomatic Atttude On Checkbox
	aszDropdownElements = ( 
		"TXT_KEY_OPTIONS_ATT_NONE",
		"TXT_KEY_OPTIONS_ATT_CIVNAME",
		"TXT_KEY_OPTIONS_ATT_ICON",
		"TXT_KEY_OPTIONS_ATT_DESC" )
	
	optscr.addGenericDropdown( canvas, "ShowAttitudeDropdown", 
		"TXT_KEY_OPTIONS_SHOWATTITUDE", aszDropdownElements, "MAINSCR",
		"show_attitude", SHOW_ATT_DEF )
	
# START - TGA | Interface Custom Optoins | 09 July 2006
	optscr.addGenericCheckbox( canvas, "MainScreenEnhCheckbox",
		"TXT_KEY_OPTIONS_MAINSCREEN_ENHANCEMENT", "MAINSCR", "main_screen_enh", False )
		
	optscr.addGenericCheckbox( canvas, "CityScreenEnhCheckbox",
		"TXT_KEY_OPTIONS_CITYSCREEN_ENHANCEMENT", "MAINSCR", "city_screen_enh", False )	
## END - TGA | 09 July 2006
	
#	# Show PlotList Button Enhancement On Checkbox
#	optscr.addGenericCheckbox( canvas, "PlotListButtonCheckbox",
#		"TXT_KEY_OPTIONS_PLOTLISTBUTTON", "MAINSCR", "enhanced_plotlist", True )

actInfo_CenterUnit = None

def onShowButton( argsList ):
	" called on CvMainInterface.py/updateSelectionButtons()"
	import ActionButton
	global actInfo_CenterUnit

	bUnitSelection, pSelectedEntity = argsList[:2]
	
	if not actInfo_CenterUnit :
		# Init action buttons
		actInfo_CenterUnit = ActionButton.createButton("center_unit")
		actInfo_CenterUnit.setHelp("Center Selected Unit")
		actInfo_CenterUnit.setButton("INTERFACE_CUSTOM_FINDUNIT")

# START - TGA |  Interface Custom Optoins  | 09 July 2006
	if not getCustomOption("MAINSCR", "main_screen_enh", False):
		return 0
# END - TGA | 09 July 2006
	if bUnitSelection :
		actInfo_CenterUnit.showButton()

def onActionButton(argsList):
	( actId, bUnitSelection, pSelectedEntity, bRightClick, iData, strData ) = argsList[:6]
	
	if bUnitSelection and actId == actInfo_CenterUnit.getID() :
		pSelectedEntity.centerCamera()
		return 1
	return 0

########## END BY SIMCUTIE ###############################################

class CvSimCutieMainInterface(CvMainInterface.CvMainInterface):
	"Main Interface Screen"

#======= ADDED BY SIMCUTIE ===============================================
	def __init__(self):
		self.parent = CvMainInterface.CvMainInterface
#		self.parent = super(CvSimCutieMainInterface, self)
		
		useOptionSection("MAINSCR")
		self.opt_ShowAttitude = getCustomOption("MAINSCR", "show_attitude", SHOW_ATT_DEF)
#		self.opt_EnhancedPlotList = getCustomOption("MAINSCR", "enhanced_plotlist", True)

		self.opt_ActionButton = True
		self.opt_SimCutieDLL = False

		# check ActionButton is installed
		try:
			import ActionButton
			self.opt_ActionButton = True
		except ImportError:
			self.opt_ActionButton = False

		if hasExtGC() :
			self.opt_SimCutieDLL = True
		
		self.bScreenInited = False
		
	def interfaceScreen (self):

		self.parent.interfaceScreen(self)

		# This is the main interface screen, create it as such
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		"""
		# *********************************************************************************
		# PLOT LIST BUTTONS
		# *********************************************************************************

		for i in range( ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 ) ):
			szString = "PlotListButton" + str(i)
#-------- ADDED BY 12monkeys ---------------------------------------------
			# place/init the promotion frame. Important to have it at first place within the for loop.
			szFileNamePromo = PyCivSim.findButton("OVERLAY_PROMOTION_FRAME")
			szStringPromoFrame = szString+"PromoFrame"
			screen.addDDSGFC( szStringPromoFrame, szFileNamePromo, 315 + (i * 34), yResolution - (169), 32, 32, WidgetTypes.WIDGET_PLOT_LIST, i, -1 )
			screen.hide( szStringPromoFrame )
#-------- END ------------------------------------------------------------
			screen.addCheckBoxGFC( szString, ArtFileMgr.getInterfaceArtInfo("INTERFACE_BUTTONS_GOVERNOR").getPath(), ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), 315 + (i * 34), yResolution - 169, 32, 32, WidgetTypes.WIDGET_PLOT_LIST, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
			screen.hide( szString )

#-------- ADDED BY 12monkeys ---------------------------------------------
			# place/init the health bar. Important to have it at last place within the for loop.
			szStringHealthBar = szString+"HealthBar"
			screen.addStackedBarGFC( szStringHealthBar, 322 + (i * 34), yResolution - 176, 25, 14, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_GENERAL, i, -1 )
			screen.setStackedBarColors( szStringHealthBar, InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_GREEN") )
			screen.setStackedBarColors( szStringHealthBar, InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_RED") )
			screen.hide( szStringHealthBar )
#-------- END ------------------------------------------------------------
"""
		self.InitCustom()

		for button, state in zip( self.minimapButtons, self.minimapButtonState ) :
			screen.setState(button, state)
		
		if self.opt_SimCutieDLL :
			if screen.getCheckBoxState("Grid") :
				getExtGC().executeHotkeyInfo( 
					gc.getControlInfo(ControlTypes.CONTROL_GRID), -1, False, False)
			if screen.getCheckBoxState("ResourceIcons"):
				getExtGC().executeHotkeyInfo( 
					gc.getControlInfo(ControlTypes.CONTROL_RESOURCE_ALL), -1, False, False)

		if screen.getCheckBoxState("BareMap"):
			CyInterface().toggleBareMapMode()
		if screen.getCheckBoxState("Yields"):
			CyInterface().toggleYieldVisibleMode()
		if not screen.getCheckBoxState("ScoresVisible"): # default is True
			CyInterface().toggleScoresVisible()

#-------------------------------------------------------------------------
#		Additional custom buttons
		# City scroll buttons above Civ Flag Pannel
		iBtnAdvance = 28
		iBtnX = xResolution - (len(self.minimapButtons) +2) * iBtnAdvance - 49 -5
		iY = yResolution - iMinimapButtonsY_Regular - 5
		iBtnWidth = 28
		screen.setButtonGFC( "CityLookMinus", u"", "", iBtnX, iY, iBtnWidth, iBtnWidth,
			WidgetTypes.WIDGET_CITY_SCROLL, -1, -1, ButtonStyles.BUTTON_STYLE_ARROW_LEFT )
		screen.setButtonGFC( "CityLookPlus", u"", "", iBtnX + iBtnAdvance, iY, iBtnWidth, iBtnWidth, 
			WidgetTypes.WIDGET_CITY_SCROLL, 1, -1, ButtonStyles.BUTTON_STYLE_ARROW_RIGHT )
				
		screen.hide("CityLookMinus")
		screen.hide("CityLookPlus")

#		if getCustomOption( "MAINSCR", "city_screen_enh", False ):
		# Enlarge city screen / AdjustPanel to accomodate more infos
		offset = CITYADJPANNEL_ENXTEND
		screen.addPanel( "CityScreenAdjustPanel", u"", u"", True, False, 10, 44, 238, 86 + offset, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "CityScreenAdjustPanel", "Panel_City_Info_Style" )
		screen.hide( "CityScreenAdjustPanel" )
		screen.moveItem("TradeRouteListBackground", 10, 138 + offset, 0.0 )
#		screen.moveItem("TradeRouteListLabel", 129, 146 + offset, -0.1 )
		screen.moveItem("BuildingListBackground", 10, 268 + offset, 0.0 )
#		screen.moveItem("BuildingListLabel", 129, 276 + offset, -0.1 )
		
		# adjust city screen / citizen button positon
		for i in range( gc.getNumSpecialistInfos() ):
			if (gc.getSpecialistInfo(i).isVisible()):
				screen.moveItem( "IncreaseSpecialist" + str(i),
					xResolution - 38, (yResolution - CITIZEN_BUTTON_BASE - 34 * i ), 0.0)
				screen.moveItem( "DecreaseSpecialist" + str(i),
					xResolution - 38, (yResolution - CITIZEN_BUTTON_BASE - 34 * i + 17), 0.0)
				screen.moveItem( "CitizenDisabledButton" + str(i),
					xResolution - 74, (yResolution - CITIZEN_BUTTON_BASE - 34 * i), 0.0)
		
				for j in range(MAX_CITIZEN_BUTTONS):
					szName = "CitizenButton" + str((i * 100) + j)
					screen.deleteWidget(szName)
		
		# Angry Citizens
		for i in range(MAX_CITIZEN_BUTTONS):
			szName = "AngryCitizen" + str(i)
			screen.deleteWidget(szName)

		return 0

	# Will redraw the interface
	def redraw( self ):

		if not self.bScreenInited:
			self.InitCustom()
		self.parent.redraw(self)
		
		return 0

	def InitCustom(self):
		" This is executed when screen is created or reloaded"

		# Added by Gerikes to properly reset globals
		# reset global used by CvMainInterface.updateSelectionButtons():
		CvMainInterface.g_NumEmphasizeInfos = gc.getNumEmphasizeInfos()
		CvMainInterface.g_NumCityTabTypes = CityTabTypes.NUM_CITYTAB_TYPES
		CvMainInterface.g_NumHurryInfos = gc.getNumHurryInfos()
		CvMainInterface.g_NumUnitClassInfos = gc.getNumUnitClassInfos()
		CvMainInterface.g_NumBuildingClassInfos = gc.getNumBuildingClassInfos()
		CvMainInterface.g_NumProjectInfos = gc.getNumProjectInfos()
		CvMainInterface.g_NumProcessInfos = gc.getNumProcessInfos()
		CvMainInterface.g_NumActionInfos = gc.getNumActionInfos()
		# End Added by Gerikes for proper python reloading

		if not PyCivSim.MyInfoMap :
			PyCivSim.InitPyCiv(None)

		attitueColorDefault = (
			( "color_no_attitude", "COLOR_X_WHITE" ),				# NO_ATTITUDE: -1
			( "color_attitude_furious", "COLOR_X_MAGENTA" ),		# ATTITUDE_FURIOUS: 0
			( "color_attitude_annoyed", "COLOR_PLAYER_PURPLE_TEXT" ),# ATTITUDE_ANNOYED: 1
			( "color_attitude_cautious", "COLOR_X_CYAN" ),			# ATTITUDE_CAUTIOUS: 2
			( "color_attitude_pleased", "COLOR_X_LIME" ),			# ATTITUDE_PLEASED: 3
			( "color_attitude_friendly", "COLOR_X_YELLOW" ) )		# ATTITUDE_FRIENDLY: 4

		self.AttitudeColors = ()
		for color in attitueColorDefault:
			self.AttitudeColors += ( PyCivSim.getColor( 
				getCustomOption( "MAINSCR", color[0], color[1])),)

		eraColorDefault = (
			( "color_era_ancient", "COLOR_PLAYER_GRAY" ),			# ERA_ANCIENT: 0
			( "color_era_classical", "COLOR_FONT_GREEN" ),			# ERA_CLASSICAL: 1
			( "color_era_medieval", "COLOR_MAGENTA" ),				# ERA_MEDIEVAL: 2
			( "color_era_renaissance", "COLOR_X_GOLD" ),			# ERA_RENAISSANCE: 3
			( "color_era_industrial", "COLOR_PLAYER_DARK_YELLOW" ),	# ERA_INDUSTRIAL: 4
			( "color_era_modern", "COLOR_CYAN" ),					# ERA_MODERN: 5
			( "color_era_future", "COLOR_X_CORNFLOWERBLUE" ) )		# ERA_FUTURE: 6

		self.EraColors = ()
		for color in eraColorDefault:
			self.EraColors += ( PyCivSim.getColor( 
				getCustomOption( "MAINSCR", color[0], color[1])),)
		
#		if not PyCivSim.findButton("OVERLAY_PROMOTION_FRAME", "" ) :
#			qPrint(__name__, "PlotList Button Enhancement art file missing")
#			setCustomOption("MAINSCR", "enhanced_plotlist", False)
#			self.opt_EnhancedPlotList = False
		
		self.minimapButtons = ["Ping", "Grid", "BareMap", "Yields", "ScoresVisible",
			"ResourceIcons"]
		myLayout = getCustomOption("MAINSCR", "minimap_buttons", ",".join(self.minimapButtons))
		
		nbut1 = len(self.minimapButtons)-1
		if myLayout.count(",") == nbut1 :
			self.minimapButtons = myLayout.split( ",", nbut1)
			s6 = getCustomOption( "MAINSCR", "minimap_buttons_state",
				"False,False,False,False,True,False" )
			self.minimapButtonState = [ bool(simpleConstValue(s)) for s in s6.split(",", nbut1) ]
			
		# Custom Button in upper-left corner
		self.iTopLeftBtnX = 27
		self.customWidgets = []
		self.customWidgetHandlers = {}

		self.bScreenInited = True #		OK, all custom enhancement
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		PyCivSim.triggerEvent( "mainHUDDraw", self, screen )
		CyInterface().setDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT, True)

#======= END BY SIMCUTIE =================================================
		
	# Update the miscellaneous buttons
	def updateMiscButtons( self ):

		self.parent.updateMiscButtons( self )
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

#		xResolution = screen.getXResolution()
#		yResolution = screen.getYResolution()
		
#======= ADDED BY SIMCUTIE =================================================
#		iBtnAdvance = 28
#		iBtnX = xResolution - (len(self.minimapButtons) +2) * iBtnAdvance - 49 -5
#		iY = yResolution - iMinimapButtonsY_Regular - 5
#		if ( CyInterface().shouldDisplayFlag() and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
#			pass
#		else:
#			pass

		updatelist = self.customWidgets[:]
		if getCustomOption( "MAINSCR", "main_screen_enh"):
			updatelist += [ "CityLookMinus", "CityLookPlus"]
		else :
			screen.hide("CityLookMinus")
			screen.hide("CityLookPlus" )
			
		if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE_ALL or CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_MINIMAP_ONLY ):
			for w in updatelist :
				screen.hide(w)
			
		elif ( CyInterface().isCityScreenUp() ):
			for w in updatelist :
				screen.hide(w)
			
		elif ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE ):
			for w in updatelist :
				screen.moveToFront(w)
				screen.show(w)
			
		elif ( CyEngine().isGlobeviewUp() ):
			for w in updatelist :
				screen.moveToFront(w)
				screen.show(w)
			
		else:
			for w in updatelist :
				screen.moveToFront(w)
				screen.show(w)
#======= END BY SIMCUTIE =================================================
			
		return 0
		
		"""
	# Update plot List Buttons
	def updatePlotListButtons( self ):

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		bHandled = False
		if ( CyInterface().shouldDisplayUnitModel() and CyEngine().isGlobeviewUp() == false and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL ):
			if ( CyInterface().isCitySelection() ):

				iOrders = CyInterface().getNumOrdersQueued()

				for i in range( iOrders ):
					if ( bHandled == False ):
						if ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_TRAIN ):
							screen.addUnitGraphicGFC( "InterfaceUnitModel", CyInterface().getOrderNodeData1(i), 190, yResolution - 138, 103, 132, WidgetTypes.WIDGET_GENERAL, -1, -1,  -20, 30, 1, False )
							bHandled = True
						elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_CONSTRUCT ):
							screen.addBuildingGraphicGFC( "InterfaceUnitModel", CyInterface().getOrderNodeData1(i), 190, yResolution - 138, 103, 132, WidgetTypes.WIDGET_GENERAL, -1, -1,  -20, 30, 0.8, False )
							bHandled = True
						elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_CREATE ):
							screen.hide( "InterfaceUnitModel" )
							bHandled = True
						elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_MAINTAIN ):
							screen.hide( "InterfaceUnitModel" )
							bHandled = True
							
				if ( not bHandled ):
					screen.hide( "InterfaceUnitModel" )
					bHandled = True

			elif ( CyInterface().getHeadSelectedUnit() ):
				screen.addUnitGraphicGFC( "InterfaceUnitModel", CyInterface().getHeadSelectedUnit().getUnitType(), 190, yResolution - 138, 103, 132, WidgetTypes.WIDGET_UNIT_MODEL, CyInterface().getHeadSelectedUnit().getUnitType(), -1,  -20, 30, 1, False )
			else:
				screen.hide( "InterfaceUnitModel" )
		else:
			screen.hide( "InterfaceUnitModel" )
			
		pPlot = CyInterface().getSelectionPlot()

		for i in range(gc.getNumPromotionInfos()):
			szName = "PromotionButton" + str(i)
			screen.moveToFront( szName )
		
		screen.hide( "PlotListMinus" )
		screen.hide( "PlotListPlus" )

		for i in range( ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 ) ):
			szString = "PlotListButton" + str(i)
			screen.hide( szString )

			# SF CHANGE
			szStringIcon = szString+"Icon"
			screen.hide( szStringIcon )

#-------- ADDED BY 12monkeys ---------------------------------------------
			# hide all additional objects, so that the can be redrawn
			szStringHealthBar = szString+"HealthBar"
			screen.hide( szStringHealthBar )
			
			szStringPromoFrame = szString+"PromoFrame"
			screen.hide( szStringPromoFrame )
			
			szStringActionIcon = szString+"ActionIcon"
			screen.hide( szStringActionIcon )
#-------- END ------------------------------------------------------------
		if ( pPlot and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyEngine().isGlobeviewUp() == False):

			iVisibleUnits = CyInterface().getNumVisibleUnits()
			iCount = -(CyInterface().getPlotListColumn())

			bLeftArrow = False
			bRightArrow = False

#-------- CHANGED BY 12monkeys -------------------------------------------
#			if ( iVisibleUnits > 1 or CyInterface().isCitySelection() ):
#-------------------------------------------------------------------------
			# changed, so that single units will get their plot list button as well
			if ( iVisibleUnits >= 1 or CyInterface().isCitySelection() ):
#-------- END ------------------------------------------------------------
				for i in range(pPlot.getNumUnits()):
					pLoopUnit = CyInterface().getInterfacePlotUnit(pPlot, i)
					if (pLoopUnit):

						if ((iCount == 0) and (CyInterface().getPlotListColumn() > 0)):
							bLeftArrow = True
						elif ((iCount == ( ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 ) - 1)) and ((iVisibleUnits - iCount - CyInterface().getPlotListColumn()) > 1)):
							bRightArrow = True

#======== CHANGED BY 12monkeys ===========================================
#						if ((iCount >= 0) and (iCount <  ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 ) )):
#							if ((pLoopUnit.getTeam() != gc.getGame().getActiveTeam()) or pLoopUnit.isWaiting()):
#								szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_FORTIFY").getPath()
#								
#							elif (pLoopUnit.canMove()):
#								if (pLoopUnit.hasMoved()):
#									szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_HASMOVED").getPath()
#								else:
#									szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_MOVE").getPath()
#							else:
#								szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_NOMOVE").getPath()
#=========================================================================
						# this if statement and everythign inside, handles the display of the
						# colored buttons in the upper left corner of each unit icon. Wounded units
						# will get a darker colored button.
						if ((iCount >= 0) and (iCount <  ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 ) )):
							if ((pLoopUnit.getTeam() != gc.getGame().getActiveTeam()) or pLoopUnit.isWaiting()):
								state_overlay = "OVERLAY_FORTIFY"
								
							elif (pLoopUnit.canMove()):
								if (pLoopUnit.hasMoved()):
									state_overlay = "OVERLAY_HASMOVED"
								else:
									state_overlay = "OVERLAY_MOVE"
							else:
								state_overlay = "OVERLAY_NOMOVE"
							
							if self.opt_EnhancedPlotList and pLoopUnit.isHurt():
								state_overlay += "_INJURED"
							
							szFileName = ArtFileMgr.getInterfaceArtInfo(state_overlay).getPath()
#======== END BY SIMCUTIE ================================================

							szString = "PlotListButton" + str(iCount)
							screen.changeImageButton( szString, gc.getUnitInfo(pLoopUnit.getUnitType()).getButton() )
							#screen.addCheckBoxGFC( szString, gc.getUnitInfo(pLoopUnit.getUnitType()).getButton(), ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), 315 + (iCount * 34), yResolution - 169, 32, 32, WidgetTypes.WIDGET_PLOT_LIST, iCount + CyInterface().getPlotListColumn(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
							if ( pLoopUnit.getOwner() == gc.getGame().getActivePlayer() ):
								bEnable = True
							else:
								bEnable = False
							screen.enable(szString, bEnable)

							if (pLoopUnit.IsSelected()):
								screen.setState(szString, True)
							else:
								screen.setState(szString, False)
							screen.show( szString )
							
#-------- ADDED BY 12monkeys ---------------------------------------------
							if self.opt_EnhancedPlotList :
								self.PlotListEnhancement( pLoopUnit, iCount )
#-------- END --------------------------------------------------------------
							# SF CHANGE 
							# Adds the overlay first
							szStringIcon = szString+"Icon"
							screen.addDDSGFC( szStringIcon, szFileName, 312 + (iCount * 34), yResolution - (172+2), 12, 12, WidgetTypes.WIDGET_PLOT_LIST, iCount, -1 )
							screen.show( szStringIcon )

						iCount = iCount + 1

			if ( iVisibleUnits >  ( ( xResolution - (iMultiListXL+iMultiListXR) - 68 ) / 34 )  ):
				screen.enable("PlotListMinus", bLeftArrow)
				screen.show( "PlotListMinus" )
	
				screen.enable("PlotListPlus", bRightArrow)
				screen.show( "PlotListPlus" )

		return 0
"""

	# Will hide and show the selection buttons and their associated buttons
	def updateSelectionButtons( self ):
	
		global g_pSelectedUnit

		self.parent.updateSelectionButtons(self)

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		pHeadSelectedUnit = CyInterface().getHeadSelectedUnit()
		
		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		if (not CyEngine().isGlobeviewUp() and pHeadSelectedCity) :
			if ((pHeadSelectedCity.getOwner() == gc.getGame().getActivePlayer()) or gc.getGame().isDebugMode()):
			
#-------- ADDED BY SIMCUTIE ----------------------------------------------
#				### ActionButtons 
				if self.bScreenInited and self.opt_ActionButton :
					iCount = 0

					# Units to construct
					for i in range ( g_NumUnitClassInfos ):
						eLoopUnit = gc.getCivilizationInfo(pHeadSelectedCity.getCivilizationType()).getCivilizationUnits(i)

						if (pHeadSelectedCity.canTrain(eLoopUnit, False, True)):
							iCount = iCount + 1

					if (iCount == 0):

						# Buildings to construct
						for i in range ( g_NumBuildingClassInfos ):
							if (not isLimitedWonderClass(i)):
								eLoopBuilding = gc.getCivilizationInfo(pHeadSelectedCity.getCivilizationType()).getCivilizationBuildings(i)

								if (pHeadSelectedCity.canConstruct(eLoopBuilding, False, True, False)):
									iCount = iCount + 1

					import ActionButton
					ActionButton.DisplayCustomButtons(screen, iCount, False, pHeadSelectedCity)
					screen.show( "BottomButtonContainer" )
#-------- END BY SIMCUTIE ------------------------------------------------
#======= ADDED BY SIMCUTIE =================================================
				visMode = CyInterface().getShowInterface()
				if ( visMode == InterfaceVisibility.INTERFACE_HIDE_ALL
					or visMode ==InterfaceVisibility.INTERFACE_MINIMAP_ONLY ):

					# Hide Selected City interface on INTERFACE_HIDE_ALL 
					
					for i in range (g_NumEmphasizeInfos):
						screen.hide(  "Emphasize" + str(i) )
					# City Tabs
					for i in range( g_NumCityTabTypes ):
						screen.hide(  "CityTab" + str(i))
					# Hurry button show...
					for i in range( g_NumHurryInfos ):
						screen.hide("Hurry" + str(i) )
					screen.hide( "Conscript" )
					screen.hide( "AutomateProduction" )
					screen.hide( "AutomateCitizens" )
					screen.hide( "BottomButtonContainer" )
					self.setMinimapButtonVisibility( False )
#======= END BY SIMCUTIE =================================================
		
		elif (not CyEngine().isGlobeviewUp() and pHeadSelectedUnit and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY):

			if (CyInterface().getInterfaceMode() == InterfaceModeTypes.INTERFACEMODE_SELECTION):
			
				if ( pHeadSelectedUnit.getOwner() == gc.getGame().getActivePlayer() and g_pSelectedUnit != pHeadSelectedUnit ):
				
#-------- ADDED BY SIMCUTIE ----------------------------------------------
					if self.bScreenInited and self.opt_ActionButton :
						g_pSelectedUnit = pHeadSelectedUnit
						
						iCount = 0

						actions = CyInterface().getActionsToShow()
						for i in actions:
							iCount = iCount + 1

						if (CyInterface().canCreateGroup()):
							iCount = iCount + 1

						if (CyInterface().canDeleteGroup()):
							iCount = iCount + 1

#						### ActionButtons -- remotely based on TALCHAS's code
						import ActionButton
						ActionButton.DisplayCustomButtons(screen, iCount, True, pHeadSelectedUnit)
						screen.show( "BottomButtonContainer" )
#-------- END BY SIMCUTIE ------------------------------------------------

		return 0
		
	# Will update the citizen buttons
	def updateCitizenButtons( self ):

		global MAX_CITIZEN_BUTTONS
		
		bHandled = False
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		for i in range( MAX_CITIZEN_BUTTONS ):
			szName = "FreeSpecialist" + str(i)
			screen.hide( szName )
			szName = "AngryCitizen" + str(i)
			screen.hide( szName )
			
		for i in range( gc.getNumSpecialistInfos() ):
			szName = "IncreaseSpecialist" + str(i)
			screen.hide( szName )
			szName = "DecreaseSpecialist" + str(i)
			screen.hide( szName )
			szName = "CitizenDisabledButton" + str(i)
			screen.hide( szName )
			for j in range(MAX_CITIZEN_BUTTONS):
				szName = "CitizenButton" + str((i * 100) + j)
				screen.hide( szName )
				szName = "CitizenButtonHighlight" + str((i * 100) + j)
				screen.hide( szName )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		if ( CyInterface().isCityScreenUp() ):
			if (pHeadSelectedCity and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW):
				if ( pHeadSelectedCity.angryPopulation(0) < MAX_CITIZEN_BUTTONS ):
					iCount = pHeadSelectedCity.angryPopulation(0)
				else:
					iCount = MAX_CITIZEN_BUTTONS

#-------- CHANGED BY SIMCUTIE --------------------------------------------
				"""
				for i in range(iCount):
					bHandled = True
					szName = "AngryCitizen" + str(i)
					screen.show( szName )
					
				iCount = 0

				bHandled = False
				for i in range(gc.getNumSpecialistInfos()):
					for j in range( pHeadSelectedCity.getFreeSpecialistCount(i) ):
						if (iCount < MAX_CITIZEN_BUTTONS):
							szName = "FreeSpecialist" + str(iCount)
							screen.setImageButton( szName, gc.getSpecialistInfo(i).getTexture(), (xResolution - 74  - (34 * iCount)), yResolution - 216, 32, 32, WidgetTypes.WIDGET_CITIZEN, i, -1 )
							screen.show( szName )
							bHandled = true

						iCount = iCount + 1
				"""
#-------------------------------------------------------------------------
				for i in range(iCount):
					bHandled = True
					szName = "AngryCitizen" + str(i)
					screen.setImageButton( szName, ArtFileMgr.getInterfaceArtInfo("INTERFACE_ANGRYCITIZEN_TEXTURE").getPath(), xResolution - 74 - (CITIZEN_BUTTON_OFFSET * i), yResolution - CITIZEN_BUTTON_BASE + 34 , 32, 32, WidgetTypes.WIDGET_ANGRY_CITIZEN, -1, -1 )
					screen.show( szName )
				
				occupied = [0] * gc.getNumSpecialistInfos()
##-------- END BY SIMCUTIE -----------------------------------------------

				for i in range( gc.getNumSpecialistInfos() ):
				
					bHandled = False

					if (pHeadSelectedCity.getOwner() == gc.getGame().getActivePlayer() or gc.getGame().isDebugMode()):
					
						if (pHeadSelectedCity.isCitizensAutomated()):
							iSpecialistCount = max(pHeadSelectedCity.getSpecialistCount(i), pHeadSelectedCity.getForceSpecialistCount(i))
						else:
							iSpecialistCount = pHeadSelectedCity.getSpecialistCount(i)
					
						if (pHeadSelectedCity.isSpecialistValid(i, 1) and iSpecialistCount < (pHeadSelectedCity.getPopulation() + pHeadSelectedCity.totalFreeSpecialists())):
							szName = "IncreaseSpecialist" + str(i)
							screen.show( szName )
							szName = "CitizenDisabledButton" + str(i)
							screen.show( szName )

						if iSpecialistCount > 0:
							szName = "CitizenDisabledButton" + str(i)
							screen.hide( szName )
							szName = "DecreaseSpecialist" + str(i)
							screen.show( szName )
							
					if (pHeadSelectedCity.getSpecialistCount(i) < MAX_CITIZEN_BUTTONS):
						iCount = pHeadSelectedCity.getSpecialistCount(i)
					else:
						iCount = MAX_CITIZEN_BUTTONS

					j = 0
					for j in range( iCount ):
						bHandled = True
						szName = "CitizenButton" + str((i * 100) + j)
#-------- CHANGED BY SIMCUTIE --------------------------------------------
						"""
						screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", xResolution - 74 - (34 * j), (yResolution - 282 - (34 * i)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
						screen.show( szName )
						szName = "CitizenButtonHighlight" + str((i * 100) + j)
						screen.addDDSGFC( szName, ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), xResolution - 74 - (34 * j), (yResolution - 282 - (34 * i)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j )
						if ( pHeadSelectedCity.getForceSpecialistCount(i) > j ):
							screen.show( szName )
						else:
							screen.hide( szName )
						
					if ( not bHandled ):
						szName = "CitizenDisabledButton" + str(i)
						screen.show( szName )
"""
#-------------------------------------------------------------------------
						screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", xResolution - 74 - (CITIZEN_BUTTON_OFFSET * j), (yResolution - CITIZEN_BUTTON_BASE - (34 * i)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
						screen.show( szName )
						szName = "CitizenButtonHighlight" + str((i * 100) + j)
						screen.addDDSGFC( szName, ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), xResolution - 74 - (CITIZEN_BUTTON_OFFSET * j), (yResolution - CITIZEN_BUTTON_BASE - (34 * i)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j )
						if ( pHeadSelectedCity.getForceSpecialistCount(i) > j ):
							screen.show( szName )
						else:
							screen.hide( szName )
						
					if ( not bHandled ):
						szName = "CitizenDisabledButton" + str(i)
						screen.show( szName )
					
					if gc.getSpecialistInfo(i).isVisible():
						nSupSp = pHeadSelectedCity.getFreeSpecialistCount(i)
						for j in range(j+2, min(j+2  + nSupSp, MAX_CITIZEN_BUTTONS)):
							bHandled = True
							szName = "CitizenButton" + str((i * 100) + j)
							screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", (xResolution - 74  - (CITIZEN_BUTTON_OFFSET * j)), (yResolution - CITIZEN_BUTTON_BASE - (34 * i)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
							screen.show( szName )

						occupied[i] = j
						visibleSps = i
					
					else:
						ii = i - visibleSps
						nSupSp = pHeadSelectedCity.getFreeSpecialistCount(i)
						j = occupied[ii] +2
						for j in range( j, min(j + nSupSp, MAX_CITIZEN_BUTTONS)):
							szName = "CitizenButton" + str((i * 100) + j)
							screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", (xResolution - 74  - (CITIZEN_BUTTON_OFFSET * j)), (yResolution - CITIZEN_BUTTON_BASE - (34 * ii)), 32, 32, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
							screen.show( szName )
#-------- END BY SIMCUTIE ------------------------------------------------

		return 0
			
	def updateTimeText( self ):
		
		global g_szTimeText
		
		ePlayer = gc.getGame().getActivePlayer()
		
# ======= CHANGED BY SIMCUTIE ============================================
# Simple Game Clock Mod
#	Show wall clock time, turn number, percent and in-game year. 
# ----- Original code ----------------------------------------------------
#		if (CyUserProfile().isClockOn()):# and bUseClockText):
#			g_szTimeText = getClockText() + u" - " + unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
#		else:
#			g_szTimeText = unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
#==========================================================================
		if not CyInterface().shiftKey() :
			clkText = ""
			if CyUserProfile().isClockOn(): 
				if CyUserProfile().is24Hours():
					clkText = time.strftime("%H:%M")
				else:
					clkText = time.strftime("%I:%M %p")
				if isAlarmOn() :
					clkText = "*" + clkText

			# display clock and Game Year
			display = u"%s  %s" % ( clkText, CyGameTextMgr().getInterfaceTimeStr(ePlayer))

		else :
			turn = gc.getGame().getElapsedGameTurns()
			maxturn =  gc.getGame().getMaxTurns()
			# first Turn is turn 1, so +1 in display
			if maxturn > 0 :
				turnText = "[%4d/%d  %3d%%]" % (turn+1, maxturn, int((100 *turn+1) / maxturn) )
			else :
				turnText = "[ %4d ]" % (turn + 1)

			eEra = gc.getPlayer(ePlayer).getCurrentEra()
			eraText = gc.getEraInfo(eEra).getDescription()
			eraText = localText.changeTextColor( eraText , self.EraColors[eEra])
			fps = self.fDelta > 0.001 and 1.0/self.fDelta or 0

			# display FPS, turn number & percent, and Era.
			display = u"fps:%5.1f %s %s" % ( fps, turnText, eraText )

		CvMainInterface.g_szTimeText = display

#======= END BY SIMCUTIE =================================================
		
	# Will update the selection Data Strings
	def updateCityScreen( self ):
	
		self.parent.updateCityScreen(self)
		
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		for ii in range( CITYADJPANNEL_TEXT_LINES*2 ) :
			screen.hide( "CityAdjText" + str(ii))
		
		if ( not CyInterface().isCityScreenUp() or not pHeadSelectedCity ):
			return
		offset = CITYADJPANNEL_ENXTEND
		
		########### TRADE ROUTES LIST ###############
		iNumTradeRoutes = 0
		iTradeProfit = [0]*YieldTypes.NUM_YIELD_TYPES
		for i in range(gc.getDefineINT("MAX_TRADE_ROUTES")):
			pLoopCity = pHeadSelectedCity.getTradeCity(i)
			if (pLoopCity and pLoopCity.getOwner() >= 0):
				for j in range( YieldTypes.NUM_YIELD_TYPES ):
					iTradeProfit[j] += pHeadSelectedCity.calculateTradeYield(j, pHeadSelectedCity.calculateTradeProfit(pLoopCity))
				iNumTradeRoutes += 1
		
		szTmp = ""
		for j in range( YieldTypes.NUM_YIELD_TYPES ):
			if (iTradeProfit[j] != 0):
				if ( iTradeProfit[j] > 0 ):
					szTmp += u" %s%d%c" %( "+", iTradeProfit[j], gc.getYieldInfo(j).getChar() )
				else:
					szTmp += u" %s%d%c" %( "", iTradeProfit[j], gc.getYieldInfo(j).getChar() )
		
		szBuf = localText.getText("TXT_KEY_HEADING_TRADEROUTE_LIST", ())
		if szTmp and getCustomOption( "MAINSCR", "city_screen_enh" ):
			szBuf += ": <font=1>%d  %s</font>" % ( iNumTradeRoutes, szTmp )
		screen.setLabel( "TradeRouteListLabel", "Background", szBuf,
			CvUtil.FONT_CENTER_JUSTIFY, 129, 146 + offset, -0.1, FontTypes.SMALL_FONT,
			WidgetTypes.WIDGET_GENERAL, -1, -1 )

		screen.moveItem( "TradeRouteTable", 10, 168 + offset, 0.0 )
		
		########### BUILDINGS LIST ###############
		screen.setLabel( "BuildingListLabel", "Background",
			localText.getText("TXT_KEY_CONCEPT_BUILDINGS", ()), CvUtil.FONT_CENTER_JUSTIFY, 
			129, 276 + offset, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		screen.addTableControlGFC( "BuildingListTable", 3, 10, 298 +offset, 238, yResolution - 522 -offset, False, False, 32, 32, TableStyles.TABLE_STYLE_STANDARD )
		screen.setStyle( "BuildingListTable", "Table_City_Style" )
		
		screen.setTableColumnHeader( "BuildingListTable", 0, u"", 108 )
		screen.setTableColumnHeader( "BuildingListTable", 1, u"", 118 )
		screen.setTableColumnHeader( "BuildingListTable", 2, u"", 10 )
		screen.setTableColumnRightJustify( "BuildingListTable", 1 )

#-------------------------------------------------------------------------
		iBuildingProfit = [0]*YieldTypes.NUM_YIELD_TYPES
#-------------------------------------------------------------------------
		i = 0
		iNumBuildings = 0
		for i in range( gc.getNumBuildingInfos() ):
			if (pHeadSelectedCity.hasBuilding(i)):
				szLeftBuffer = gc.getBuildingInfo(i).getDescription()
				szRightBuffer = u""
				bFirst = True

				if (pHeadSelectedCity.hasActiveBuilding(i)):
					iHealth = pHeadSelectedCity.getBuildingHealth(i)

					if (iHealth != 0):
						if ( bFirst == False ):
							szRightBuffer = szRightBuffer + ", "
						else:
							bFirst = False
							
						if ( iHealth > 0 ):
							szTempBuffer = u"+%d%c" %( iHealth, CyGame().getSymbolID(FontSymbols.HEALTHY_CHAR) )
							szRightBuffer = szRightBuffer + szTempBuffer
						else:
							szTempBuffer = u"+%d%c" %( -(iHealth), CyGame().getSymbolID(FontSymbols.UNHEALTHY_CHAR) )
							szRightBuffer = szRightBuffer + szTempBuffer

					iHappiness = pHeadSelectedCity.getBuildingHappiness(i)

					if (iHappiness != 0):
						if ( bFirst == False ):
							szRightBuffer = szRightBuffer + ", "
						else:
							bFirst = False
							
						if ( iHappiness > 0 ):
							szTempBuffer = u"+%d%c" %(iHappiness, CyGame().getSymbolID(FontSymbols.HAPPY_CHAR) )
							szRightBuffer = szRightBuffer + szTempBuffer
						else:
							szTempBuffer = u"+%d%c" %( -(iHappiness), CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR) )
							szRightBuffer = szRightBuffer + szTempBuffer

					for j in range( YieldTypes.NUM_YIELD_TYPES):
						iYield = gc.getBuildingInfo(i).getYieldChange(j)

						if (iYield != 0):
							if ( bFirst == False ):
								szRightBuffer = szRightBuffer + ", "
							else:
								bFirst = False
								
							if ( iYield > 0 ):
								szTempBuffer = u"%s%d%c" %( "+", iYield, gc.getYieldInfo(j).getChar() )
								szRightBuffer = szRightBuffer + szTempBuffer
							else:
								szTempBuffer = u"%s%d%c" %( "", iYield, gc.getYieldInfo(j).getChar() )
								szRightBuffer = szRightBuffer + szTempBuffer
#-------------------------------------------------------------------------
							iBuildingProfit[j] += iYield
#-------------------------------------------------------------------------

				for j in range(CommerceTypes.NUM_COMMERCE_TYPES):
					iCommerce = pHeadSelectedCity.getBuildingCommerceByBuilding(j, i)

					if (iCommerce != 0):
						if ( bFirst == False ):
							szRightBuffer = szRightBuffer + ", "
						else:
							bFirst = False
							
						if ( iCommerce > 0 ):
							szTempBuffer = u"%s%d%c" %( "+", iCommerce, gc.getCommerceInfo(j).getChar() )
							szRightBuffer = szRightBuffer + szTempBuffer
						else:
							szTempBuffer = u"%s%d%c" %( "", iCommerce, gc.getCommerceInfo(j).getChar() )
							szRightBuffer = szRightBuffer + szTempBuffer

				szBuffer = szLeftBuffer + "  " + szRightBuffer
				
				screen.appendTableRow( "BuildingListTable" )
				screen.setTableText( "BuildingListTable", 0, iNumBuildings, "<font=1>" + szLeftBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_BUILDING, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
				screen.setTableText( "BuildingListTable", 1, iNumBuildings, "<font=1>" + szRightBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_BUILDING, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
				
				iNumBuildings = iNumBuildings + 1
		
		#=================================================================

		iMaintenance = pHeadSelectedCity.getMaintenance()
		iGoldRateBase = pHeadSelectedCity.getBaseYieldRate(YieldTypes.YIELD_COMMERCE)
		iGoldRatePlot = iGoldRateBase - ( iBuildingProfit[YieldTypes.YIELD_COMMERCE]
			+ pHeadSelectedCity.getExtraSpecialistYield(YieldTypes.YIELD_COMMERCE)
			+ iTradeProfit[YieldTypes.YIELD_COMMERCE] )
		iProductionRate = pHeadSelectedCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) 
		iProductionRateBase = pHeadSelectedCity.getBaseYieldRate(YieldTypes.YIELD_PRODUCTION)

		# Net Food
		# If this is a food production (i.e., worker or settler)
		if (pHeadSelectedCity.isFoodProduction()):
			iNetFood = pHeadSelectedCity.getCurrentProductionDifference (False, False) - pHeadSelectedCity.getCurrentProductionDifference (True, False)
		else:
			iNetFood = pHeadSelectedCity.foodDifference (True)
		# the food stored in the city
		iFoodStore = pHeadSelectedCity.getFood()
		
		#iFoodRateBase = pHeadSelectedCity.getBaseYieldRate(YieldTypes.YIELD_FOOD)
		#iFoodRate = pHeadSelectedCity.getYieldRate(YieldTypes.YIELD_FOOD)
		#iResearchRate = pHeadSelectedCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH)
		#iCultureRate = pHeadSelectedCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)
		#iCultureTotal = pHeadSelectedCity.getCulture()
		#iGreatPeopleRate = pHeadSelectedCity.getGreatPeopleRate()
		#iGreatPeopleTotal = pHeadSelectedCity.getGreatPeopleProgress()
		
		contents = ( # ( "left-label", "right-value", widgetType, wt_arg )
			( "INTERFACE_CITY_MAINTENANCE", str(-iMaintenance) + PyCivSim.getIcon("money"),
				WidgetTypes.WIDGET_HELP_MAINTENANCE, -1 ),
			( "TXT_KEY_MAIN_CITY_YIELD_COMMERCE", u"%d%s/%d%s" % 
				(iGoldRatePlot, PyCivSim.getIcon("commerce"), iGoldRateBase, PyCivSim.getIcon("commerce")),
				WidgetTypes.WIDGET_GENERAL, -1),
			( "TXT_KEY_MAIN_CITY_YIELD_PROD", u"%d%s/%d%s" % 
				( iProductionRateBase, PyCivSim.getIcon("production"),
				iProductionRate, PyCivSim.getIcon("production")),
				WidgetTypes.WIDGET_PRODUCTION_MOD_HELP, -1 ),
			# net food production/ stored food
			( "TXT_KEY_MAIN_CITY_YIELD_FOOD", u"%+d%s/%d%s" % 
				( iNetFood, PyCivSim.getIcon("food"), iFoodStore, PyCivSim.getIcon("food")),
				WidgetTypes.WIDGET_GENERAL, -1),)
		
		if getCustomOption( "MAINSCR", "city_screen_enh" ):
			screen.hide( "MaintenanceText" )
			screen.hide( "MaintenanceAmountText" )
			for row in range(CITYADJPANNEL_TEXT_LINES):
				content = contents[row]
				screen.setLabel( "CityAdjText" + str(row*2) , "Background",
					"<font=1>" + localText.getText(content[0], ())  + "</font>",
					CvUtil.FONT_LEFT_JUSTIFY, 15, 107 + row * 20, -0.3,
					FontTypes.SMALL_FONT, content[2], content[3], -1 )
				screen.show( "CityAdjText" + str(row*2) )
				
				screen.setLabel( "CityAdjText" + str(row*2 +1), "Background",
					"<font=1>" + content[1] + "</font>", CvUtil.FONT_RIGHT_JUSTIFY,
					220, 107 + row * 20, -0.3, FontTypes.SMALL_FONT, content[2], content[3], -1 )
				screen.show( "CityAdjText" + str(row*2 +1) )
	
	# Will update the info pane strings
	def updateInfoPaneStrings( self ):
	
		self.parent.updateInfoPaneStrings(self)
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		pHeadSelectedUnit = CyInterface().getHeadSelectedUnit()
		
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

#-------- ADDED BY SIMCUTIE ----------------------------------------------
		screen.hide( "SelectedUnitPromo" )
		# START - TGA | Interface custom options | 09 July 2006
		if not getCustomOption("MAINSCR", "main_screen_enh", False):
			return 0
		# END - TGA | Interface custom options | 09 July 2006
#-------- END BY SIMCUTIE ------------------------------------------------
		
		if CyEngine().isGlobeviewUp():
			return

		if (pHeadSelectedCity):
			if CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_SHOW :
				screen.hide( "SelectedCityText" )
				screen.hide( "SelectedUnitPanel" )
				
		elif (pHeadSelectedUnit and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW):
			
			if (CyInterface().mirrorsSelectionGroup()):
				pSelectedGroup = pHeadSelectedUnit.getGroup()
			else:
				pSelectedGroup = 0

			if (CyInterface().getLengthSelectionList() > 1):
				pass
			else:
			
				if ((pSelectedGroup == 0) or (pSelectedGroup.getLengthMissionQueue() <= 1)):
#-------- ADDED BY SIMCUTIE ---------------------------------------------
					# Possible promotion steps indicated by # of stars
					button = self.getPromoIcon(pHeadSelectedUnit)
					if button :
						screen.addDDSGFC( "SelectedUnitPromo", button, 180, yResolution -34,
							20, 20, WidgetTypes.WIDGET_HELP_SELECTED, -1, -1 )
						screen.show( "SelectedUnitPromo" )
#-------- END BY SIMCUTIE ------------------------------------------------

		return 0
		
	# Will update the scores
	def updateScoreStrings( self ):

		if self.opt_ShowAttitude == 0 :		# showAttitue == NONE
			self.parent.updateScoreStrings(self)
			return 0
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		screen.hide( "ScoreBackground" )
		
		for i in range( 20 ):
			szName = "ScoreText" + str(i)
			screen.hide( szName )

		iWidth = 0
		iCount = 0
		iBtnHeight = 22
		
		if (CyInterface().isScoresVisible() and not CyInterface().isCityScreenUp() and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY and CyEngine().isGlobeviewUp() == false):

			i = gc.getMAX_CIV_TEAMS() - 1
			while (i > -1):
				eTeam = gc.getGame().getRankTeam(i)

				if (gc.getTeam(gc.getGame().getActiveTeam()).isHasMet(eTeam) or gc.getTeam(eTeam).isHuman() or gc.getGame().isDebugMode()):
					j = gc.getMAX_CIV_PLAYERS() - 1
					while (j > -1):
						ePlayer = gc.getGame().getRankPlayer(j)

#-------- CHANGED BY SIMCUTIE --------------------------------------------
#						if (gc.getPlayer(ePlayer).isEverAlive() and not gc.getPlayer(ePlayer).isMinorCiv()):
#-------------------------------------------------------------------------
						# Hide the dead ones -- by Porges
						if (gc.getPlayer(ePlayer).isEverAlive() and not gc.getPlayer(ePlayer).isMinorCiv() and gc.getPlayer(ePlayer).isAlive()):	
#-------- END BY SIMCUTIE ------------------------------------------------
							if (gc.getPlayer(ePlayer).getTeam() == eTeam):
								szBuffer = u"<font=2>"

								if (gc.getGame().isGameMultiPlayer()):
									if (not (gc.getPlayer(ePlayer).isTurnActive())):
										szBuffer = szBuffer + "*"

								if (not CyInterface().isFlashingPlayer(ePlayer) or CyInterface().shouldFlash(ePlayer)):
									if (ePlayer == gc.getGame().getActivePlayer()):
										szTempBuffer = u"%d: [<color=%d,%d,%d,%d>%s</color>]" %(gc.getGame().getPlayerScore(ePlayer), gc.getPlayer(ePlayer).getPlayerTextColorR(), gc.getPlayer(ePlayer).getPlayerTextColorG(), gc.getPlayer(ePlayer).getPlayerTextColorB(), gc.getPlayer(ePlayer).getPlayerTextColorA(), gc.getPlayer(ePlayer).getName())
									else:
										szTempBuffer = u"%d: <color=%d,%d,%d,%d>%s</color>" %(gc.getGame().getPlayerScore(ePlayer), gc.getPlayer(ePlayer).getPlayerTextColorR(), gc.getPlayer(ePlayer).getPlayerTextColorG(), gc.getPlayer(ePlayer).getPlayerTextColorB(), gc.getPlayer(ePlayer).getPlayerTextColorA(), gc.getPlayer(ePlayer).getName())
								else:
									szTempBuffer = u"%d: %s" %(gc.getGame().getPlayerScore(ePlayer), gc.getPlayer(ePlayer).getName())
								szBuffer = szBuffer + szTempBuffer

#-------- CHANGED BY SIMCUTIE --------------------------------------------
								"""
								if (gc.getTeam(eTeam).isAlive()):
									if ( not (gc.getTeam(gc.getGame().getActiveTeam()).isHasMet(eTeam)) ):
										szBuffer = szBuffer + (" ?")
									if (gc.getTeam(eTeam).isAtWar(gc.getGame().getActiveTeam())):
										szBuffer = szBuffer + "("  + localText.getColorText("TXT_KEY_CONCEPT_WAR", (), gc.getInfoTypeForString("COLOR_RED")).upper() + ")"
									if (gc.getPlayer(ePlayer).canTradeNetworkWith(gc.getGame().getActivePlayer()) and (ePlayer != gc.getGame().getActivePlayer())):
										szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.TRADE_CHAR))
										szBuffer = szBuffer + szTempBuffer
									if (gc.getTeam(eTeam).isOpenBorders(gc.getGame().getActiveTeam())):
										szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.OPEN_BORDERS_CHAR))
										szBuffer = szBuffer + szTempBuffer
									if (gc.getTeam(eTeam).isDefensivePact(gc.getGame().getActiveTeam())):
										szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.DEFENSIVE_PACT_CHAR))
										szBuffer = szBuffer + szTempBuffer
"""
#-------------------------------------------------------------------------

								if (gc.getTeam(eTeam).isAlive()):
									if self.opt_ShowAttitude > 0 :
										szBuffer += self.DoAttitude( ePlayer )
									szTempBuffer =""
									if ( not (gc.getTeam(gc.getGame().getActiveTeam()).isHasMet(eTeam)) ):
										szTempBuffer = szTempBuffer + (" ?")
									if (gc.getTeam(eTeam).isAtWar(gc.getGame().getActiveTeam())):
										szTempBuffer = szTempBuffer + PyCivSim.getIcon("war")
									if (gc.getTeam(eTeam).isDefensivePact(gc.getGame().getActiveTeam())):
										szTempBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.DEFENSIVE_PACT_CHAR))
									if (gc.getTeam(eTeam).isOpenBorders(gc.getGame().getActiveTeam())):
										szTempBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.OPEN_BORDERS_CHAR))
									if (gc.getPlayer(ePlayer).canTradeNetworkWith(gc.getGame().getActivePlayer()) and (ePlayer != gc.getGame().getActivePlayer())):
										szTempBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.TRADE_CHAR))
									szTempBuffer = PyCivSim.getIcon("blank") * qbound(( 2 - len(szTempBuffer)), 0, 2) + szTempBuffer
									szBuffer += szTempBuffer
#-------- END BY SIMCUTIE ------------------------------------------------
									if (gc.getPlayer(ePlayer).getStateReligion() != -1):
										if (gc.getPlayer(ePlayer).hasHolyCity(gc.getPlayer(ePlayer).getStateReligion())):
											szTempBuffer = u"%c" %(gc.getReligionInfo(gc.getPlayer(ePlayer).getStateReligion()).getHolyCityChar())
											szBuffer = szBuffer + szTempBuffer
										else:
											szTempBuffer = u"%c" %(gc.getReligionInfo(gc.getPlayer(ePlayer).getStateReligion()).getChar())
											szBuffer = szBuffer + szTempBuffer
#-------- ADDED BY SIMCUTIE ----------------------------------------------
									else:
										szBuffer += PyCivSim.getIcon("blank")
#-------- END BY SIMCUTIE ------------------------------------------------
												
								if (((gc.getPlayer(ePlayer).getTeam() == gc.getGame().getActiveTeam()) and (gc.getTeam(gc.getGame().getActiveTeam()).getNumMembers() > 1)) or gc.getGame().isDebugMode()):
									if (gc.getPlayer(ePlayer).getCurrentResearch() != -1):
										szTempBuffer = u"-%s (%d)" %(gc.getTechInfo(gc.getPlayer(ePlayer).getCurrentResearch()).getDescription(), gc.getPlayer(ePlayer).getResearchTurnsLeft(gc.getPlayer(ePlayer).getCurrentResearch(), True))
										szBuffer = szBuffer + szTempBuffer
								if (CyGame().isNetworkMultiPlayer()):
									szBuffer = szBuffer + CyGameTextMgr().getNetStats(ePlayer)
									
								if (gc.getPlayer(ePlayer).isHuman() and CyInterface().isOOSVisible()):
									szTempBuffer = u" <color=255,0,0>* %s *</color>" %(CyGameTextMgr().getOOSSeeds(ePlayer))
									szBuffer = szBuffer + szTempBuffer
									
								szBuffer = szBuffer + "</font>"

								if ( CyInterface().determineWidth( szBuffer ) > iWidth ):
									iWidth = CyInterface().determineWidth( szBuffer )

								szName = "ScoreText" + str(ePlayer)
								if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
									yCoord = yResolution - 206
								else:
									yCoord = yResolution - 88
								screen.setText( szName, "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 12, yCoord - (iCount * iBtnHeight), -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_CONTACT_CIV, ePlayer, -1 )
								screen.show( szName )
								screen.setTextBackgroundPane( szName, gc.getInfoTypeForString("COLOR_BLACK") )

								CyInterface().checkFlashReset(ePlayer)

								iCount = iCount + 1
						j = j - 1
				i = i - 1

			if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
				yCoord = yResolution - 186
			else:
				yCoord = yResolution - 68
			screen.setPanelSize( "ScoreBackground", xResolution - 21 - iWidth, yCoord - (iBtnHeight * iCount) - 4, iWidth + 12, (iBtnHeight * iCount) + 8 )
			screen.show( "ScoreBackground" )

	# Update minimap buttons
	def setMinimapButtonVisibility( self, bVisible):
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		kInterface = CyInterface()
		kGLM = CyGlobeLayerManager()
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		if ( CyInterface().isCityScreenUp() ):
			bVisible = False
		
		kMainButtons = ["Ping", "Grid", "BareMap", "Yields", "ScoresVisible", "ResourceIcons"]
		kGlobeButtons = []
		for i in range(kGLM.getNumLayers()):
			szButtonID = "GlobeLayer" + str(i)
			kGlobeButtons.append(szButtonID)
#------- ADDED BY SIMCUTIE -----------------------------------------------
		if self.minimapButtons :
			kMainButtons = self.minimapButtons
#------- END BY SIMCUTIE --------------------------------------------------
		
		if bVisible:
			if CyEngine().isGlobeviewUp():
				kHide = kMainButtons
				kShow = kGlobeButtons
			else:
				kHide = kGlobeButtons
				kShow = kMainButtons
			screen.show( "GlobeToggle" )
			
		else:
			kHide = kMainButtons + kGlobeButtons
			kShow = []
			screen.hide( "GlobeToggle" )
		
		for szButton in kHide:
			screen.hide(szButton)
		
		if CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE:
			iY = yResolution - iMinimapButtonsY_Minimal
			iGlobeY = yResolution - iGlobeButtonY_Minimal 
		else:
			iY = yResolution - iMinimapButtonsY_Regular
			iGlobeY = yResolution - iGlobeButtonY_Regular
			
		iBtnX = xResolution - 39
		screen.moveItem("GlobeToggle", iBtnX, iGlobeY, 0.0)
		
		iBtnAdvance = 28
		iBtnX = iBtnX - len(kShow)*iBtnAdvance - 10
		if len(kShow) > 0:		
			i = 0
			for szButton in kShow:
				screen.moveItem(szButton, iBtnX, iY, 0.0)
				screen.moveToFront(szButton)
				screen.show(szButton)
				iBtnX += iBtnAdvance
				i += 1
				
	# Will handle the input for this screen...
	def handleInput (self, inputClass):

		inputWidget = inputClass.getFunctionName()
		if inputWidget in self.customWidgetHandlers :
			inputCode = inputClass.getNotifyCode()
			if inputCode == NotifyCode.NOTIFY_CLICKED :
				handlers = self.customWidgetHandlers[inputWidget]
				handlers[0]( inputClass.getID() )
				return 1
		
		return 0
	
	def update(self, fDelta):
		self.fDelta = fDelta
		return
	
#======= ADDED BY SIMCUTIE ==============================================
#	def handleInput (self, inputClass):
#		return 0 ### Spelldemo Mod - left this alone, the button is caught at CvGameUtils

	def getScreen(self):
		return CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

	def addTopLeftButton(self, buttonName, buttonPath = "", index = -1 ):
		
		assert buttonName
		iBtnY = 27
		iBtnWidth = 28
		self.iTopLeftBtnX += 28			# TopLeftBtn Advance

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		screen.setImageButton( buttonName, buttonPath, self.iTopLeftBtnX, iBtnY - 2, 
#		screen.setImageButton( buttonName, buttonPath, 100, 100, 
			iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_GENERAL, index, -1 )
		screen.hide(buttonName)

		self.customWidgets.append(buttonName)

	def setCustomWidgetHandler(self, buttonName, widgetHandler, helpHandler = None):
		if buttonName[-1].isdigit() :
			buttonName = buttonName[:-1]

		assert buttonName and callable(widgetHandler)
		self.customWidgetHandlers[buttonName ] = ( widgetHandler, helpHandler )

	def onCloseOption(self, argsList):
		"option screen closed. Re-read changed options"
		self.opt_ShowAttitude = getCustomOption("MAINSCR", "show_attitude" )
#		self.opt_EnhancedPlotList = getCustomOption("MAINSCR", "enhanced_plotlist", True)
		
		CyInterface().setDirty(InterfaceDirtyBits.Score_DIRTY_BIT, True)
		CyInterface().setDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT, True)
		CyInterface().setDirty(InterfaceDirtyBits.InfoPane_DIRTY_BIT, True)
		CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, True)
#		CyInterface().setDirty(InterfaceDirtyBits.PlotListButtons_DIRTY_BIT, True)
	
	def onUnInit(self, argsList):
		" This is called on game UnInit event"
		from CvCustomOption import CustomProfile

		if not self.bScreenInited :	# if not initialized...
			return
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		# save minimap button state
		self.minimapButtonState = [ bool(screen.getCheckBoxState(button))
			for button in self.minimapButtons ] 
		setCustomOption("MAINSCR", "minimap_buttons_state", 
			str(self.minimapButtonState).replace(" ", "")[1:-1] )
		CustomProfile.saveConfig()
	
	def DoAttitude( self, ePlayer ):
		" Append diplomatic attitude indication in Civ score list (Bottom Right Overlay)"
		showAttitude = self.opt_ShowAttitude
		buf = PyCivSim.getIcon("blank")	# do nothing
		if ( ePlayer != gc.getGame().getActivePlayer() 
			and not gc.getPlayer(ePlayer).isHuman() ) :	# A.I. player.
			# Show Diplomatic Attitude ( iAtt =  -1 ~ 4 )
			iAtt = gc.getPlayer(ePlayer).AI_getAttitude(gc.getGame().getActivePlayer())
			if showAttitude == 1 :	#	by Civ name color
				att = gc.getPlayer(ePlayer).getCivilizationShortDescription(0)
				buf = localText.changeTextColor( att, self.AttitudeColors[iAtt+1])
				buf = u": %s " % buf
			elif showAttitude == 2 :	#	by attitude Icon
				att = unichr(ord(PyCivSim.getIcon( "furious" )) + iAtt )
				buf = u" %s" % att
			elif showAttitude == 3 :	# by attitude desc.
				att = gc.getAttitudeInfo( iAtt ).getDescription()
				buf = localText.changeTextColor( att, self.AttitudeColors[iAtt+1])
				buf = u": %s " % buf
		else:
			if showAttitude == 1 :
				att = gc.getPlayer(ePlayer).getCivilizationShortDescription(0)
				buf = u" %s" % att
		return buf

#-------- Promotion Indicator Icon ---------------------------------------
# this code is partly based on 12Monkeys code, Thanks.
	def getPromoIcon(self, pUnit ):
		" get icon of possible promotion steps indicated by # of stars"
		def GetIdxOfXP(iXP):
			" Calculates index of an XP point"
			iLevel = 0
			iIdx = 0
			while iLevel <= iXP:
				iIdx += 1
				if iIdx == 1:
					iLevel = 2
				else:
					iLevel += (iIdx-1)*2+1
			return iIdx-1
		
		# Calculates the number of possible promotions between two XP values"
		numPromos = ( GetIdxOfXP( pUnit.getExperience())
			- GetIdxOfXP( pUnit.experienceNeeded())+1 )

		if numPromos > 0 :
			btnName = "PROMOTION_COMBAT%1d" % min(numPromos, 5)
			return gc.getPromotionInfo(gc.getInfoTypeForString(btnName)).getButton()
		else :
			return None

#======= END BY SIMCUTIE ================================================
#======= ADDED BY 12monkeys ==============================================
#	### Display PlotList Button Enhancement
#	def PlotListEnhancement(self, pUnit, iCount ):
#		
#		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
#		yResolution = screen.getYResolution()
#		szString = "PlotListButton" + str(iCount)
#
#		# can unit be promoted ?
#		if (pUnit.isPromotionReady()):
#			# place the promotion frame
#			szStringPromoFrame = szString+"PromoFrame"
#			screen.show( szStringPromoFrame )
#		
#		# place the health bar
#		szStringHealthBar = szString+"HealthBar"
#		screen.setBarPercentage( szStringHealthBar, InfoBarTypes.INFOBAR_STORED, 
#			float( pUnit.currHitPoints() ) / float( pUnit.maxHitPoints() ) )
#		screen.setBarPercentage( szStringHealthBar, InfoBarTypes.INFOBAR_RATE, float(1.0) )
#		screen.show( szStringHealthBar )
#		
#		# place the activity info below the unit icon.
#		act_overlay = ""; iOffset = 0
#		act = pUnit.getGroup().getActivityType()
#		auto_act = pUnit.getGroup().getAutomateType()
#		# is unit on air patrol/intercept mission
#		if act == ActivityTypes.ACTIVITY_INTERCEPT:
#			act_overlay = "OVERLAY_ACTION_PATROL" ; iOffset = 14	# "PAT" icon
#		# is unit fortified for healing (wake up when healed)
#		elif act == ActivityTypes.ACTIVITY_HEAL:
#			act_overlay = "OVERLAY_ACTION_HEAL" ; iOffset = 10		# "HEAL" icon
#		# is unit sentry (wake up when enemy in sight)
#		elif act == ActivityTypes.ACTIVITY_SENTRY:
#			act_overlay = "OVERLAY_ACTION_SENTRY"; iOffset = 13 	# "SEN" icon
#		# is the turn for this unit skipped (wake up next turn)
#		elif act == ActivityTypes.ACTIVITY_HOLD:
#			act_overlay = "OVERLAY_ACTION_SKIP"; iOffset = 13		# "SKIP" icon
#		# has unit explaration mission
#		elif auto_act == AutomateTypes.AUTOMATE_EXPLORE:
#			act_overlay = "OVERLAY_ACTION_EXPLORE"; iOffset = 14	# "EXP" icon
#		# is unit automated generally (only worker units)
#		elif auto_act == AutomateTypes.AUTOMATE_BUILD:
#			act_overlay = "OVERLAY_ACTION_AUTO_BUILD"; iOffset = 8	# "AUT-B" icon
#		# is unit automated for nearest city (only worker units)
#		elif auto_act == AutomateTypes.AUTOMATE_CITY:
#			act_overlay = "OVERLAY_ACTION_AUTO_CITY"; iOffset = 8	# "AUT-C" icon
#		# is unit automated for network(only worker units)
#		elif auto_act == AutomateTypes.AUTOMATE_NETWORK:
#			act_overlay = "OVERLAY_ACTION_AUTO_NETWORK"; iOffset = 8	# "AUT-N" icon
#		# has unit a mission
#		elif (pUnit.getGroup().getLengthMissionQueue() > 0):
#			# is the mission a "move to" mission
#			if pUnit.getGroup().getMissionType(0) in \
#				( MissionTypes.MISSION_MOVE_TO, MissionTypes.MISSION_MOVE_TO_UNIT) :	
#				act_overlay = "OVERLAY_ACTION_GOTO"; iOffset = 6		# "GOTO" icon
#		# if nothing of above, but unit is waiting -> unit is fortified
#		elif (pUnit.isWaiting()):
#			act_overlay = "OVERLAY_ACTION_FORTIFY"; iOffset = 8			# "FORT" icon
#		
#		if act_overlay :
#			szStringActionIcon = szString+"ActionIcon"
#			szFileNameAction = PyCivSim.findButton(act_overlay)
#			screen.addDDSGFC( szStringActionIcon, szFileNameAction, 312+iOffset + (iCount * 34), yResolution - (168-28), 32, 8, WidgetTypes.WIDGET_PLOT_LIST, iCount, -1 )
#			screen.show( szStringActionIcon )
#	
#-------- 12Monkeys Reinit Interceptor Mission mod ----------------------
#	# Restart air patrol/interceptor animation after game load 
#	def doReInitInterceptor (self):
#		from  PyHelpers import PyPlayer
#		
#		unitList = PyPlayer(CyGame().getActivePlayer()).getUnitList()
#		# Loop for players units
#		for pLoopUnit in unitList:
#			# get the group the unit belongs to. 
#			pGroup = pLoopUnit.getGroup()
#			# check if unit is doing air patrol
#			if (pGroup.getActivityType() == ActivityTypes.ACTIVITY_INTERCEPT):
#				# remove mission (this one should be obsolete, but who knows ;)
#				pGroup.popMission()
#				pPlot = pGroup.plot()
#				# add new mission -> fortify
#				pGroup.pushMission(MissionTypes.MISSION_FORTIFY, 0, 0, 0, false, false, MissionAITypes.NO_MISSIONAI, pPlot, pLoopUnit)
#				# add new mission -> air patrol
#				# *TODO* DEBUG: somethines C++ Error 
#				pGroup.pushMission(MissionTypes.MISSION_AIRPATROL, 0, 0, 0, false, false, MissionAITypes.NO_MISSIONAI, pPlot, pLoopUnit)



#======== END BY SIMCUTIE ================================================