# Genetic AI algorithm by TGA

from CvPythonExtensions import *
import CvUtil
gameData = []
from PyHelpers import *
from genAIStorage import *
from CvGameUtils import *
from copy import deepcopy
from genAIEnums import *
from AITester import *

AIStore = geneticAIStorage()
tmpAIList = []
gameAIList = []
iNumGamePlayers = 18

# globals
gc = CyGlobalContext()
localText = CyTranslator()

def EventHandlerRegister(evt_mgr, unused = None):
	CvUtil.pyPrint( __name__ + ": Event handler register OK." )
		
	return  { 
			"victory+"  		: 	onVictory,	
			"GameStart-"		:	onGameStart,
			"OnPreSave"			:	onPreSave,
			"OnLoad"			:	onLoad,
			#"BeginPlayerTurn" 	:	onBeginPlayerTurn,
			}

# def onBeginPlayerTurn(argsList):
	# iGameTurn, iPlayer = argsList
	
	# if iGameTurn > 30:
		# if not gc.getPlayer(iPlayer).isBarbarian():
			# if gc.getPlayer(iPlayer).getNumUnits() < 2:
				# print "XXXXXXXXXXXX -- CRAP AI!!"
				# print gameAIList[iPlayer].getAIName()
				# print "XXXXXXXXXXXX"
				
	# if iGameTurn == 35:
		# AILogger().newGame()
			
def getGameData():
	return gameData
		
def getGameAIList():
	return gameAIList	

def setNumPlayers(iNumPlayers):
	global iNumGamePlayers
	
	iNumGamePlayers = iNumPlayers
	
def generateGameAIs():
	global gameData
	global tmpAIList	
	
	gameData = [CyMap().getMapScriptName(), int(CyMap().getWorldSize()), CyGame().getGameSpeedType()]
		
	tmpAIList = AIStore.getAIs(iNumGamePlayers)
	
	if AIStore.bTestComplete:
		addFinishedPopup()
	
def onGameStart(argsList):

	if AIStore.bTestComplete:
		addFinishedPopup()

def onVictory(argsList):	
	iTeam, iVictory = argsList

	global gameData
	global gameAIList	
		
	finishedAIList = []
		
	for iAI in range(len(gameAIList)):
		AI = gameAIList[iAI]
		# Only save the AI data if the AI is a valid AI otherwise just send it back
		if (gc.getPlayer(iAI).isEverAlive()) and not (gc.getPlayer(iAI).isHuman()) and not (gc.getPlayer(iAI).isBarbarian()):
			AI.setFitness(calculateScore(iAI, True))
			AI.setStat(STAT_SCORE, AI.getFitness())
			
			# These, while playing no part in the actual decision making proccess, are quite fun to look at:
			stats = getPlayerStats(iAI, iVictory)

			history = deepcopy(gameData)
			history += [calculateScore(iAI, False)]
			history += [CyGame().getPlayerRank(iAI)]
			history += stats
			
			for iStat in range(1, NUM_STATS):
				stat = AI.getStat(iStat)
				# Stats are preseverd from parents with much less weight
				stat *= (AI.getNumGames() + 1)
				# First stat is score
				stat += stats[iStat - 1]
				stat /= (AI.getNumGames() + 2)
				AI.setStat(iStat, stat)
			
			AI.getGameHistory().append(history)
			finishedAIList.append(AI)
		else:
			finishedAIList.append(AI)
						
	AIStore.recieveAIs(finishedAIList)
	
	gameData = []
	gameAIList = []

## Using score as a tester
def calculateScore(iPlayer, bAverage):
	pPlayer = gc.getPlayer(iPlayer)
	iTeam = pPlayer.getTeam()
	AI = gameAIList[iPlayer]
	
	if CyGame().getWinner() == iTeam:
		bVictory = True
	else:
		bVictory = False
	
	oldFitness = AI.getFitness() * len(AI.getGameHistory())
	
	if pPlayer.isAlive():
		newFitness = CvGameUtils().calculateScore((iPlayer, true, bVictory))
	else:
		newFitness = 0
		
	if bAverage:
		newFitness += oldFitness
		newFitness /= (len(AI.getGameHistory()) + 1)
	
	return newFitness
	
def getPlayerStats(iPlayer, iVictory):
	# Stolen mostly from CvInfoScreen
	pPlayer = gc.getPlayer(iPlayer)

	iEconomy = pPlayer.calculateTotalYield(YieldTypes.YIELD_COMMERCE) - pPlayer.calculateInflatedCosts()
	iIndustry = pPlayer.calculateTotalYield(YieldTypes.YIELD_PRODUCTION)
	iAgriculture = pPlayer.calculateTotalYield(YieldTypes.YIELD_FOOD)
	iMilitary = pPlayer.getPower()
	iLandArea = pPlayer.getTotalLand()
	iPopulation = pPlayer.getRealPopulation()		
	iCulture = pPlayer.countTotalCulture()
	iReligion = pPlayer.countTotalHasReligion()

	statsList = []
	statsList.append(iEconomy)
	statsList.append(iIndustry)
	statsList.append(iAgriculture)
	statsList.append(iMilitary)
	statsList.append(iLandArea)
	statsList.append(iPopulation)
	statsList.append(iCulture)
	statsList.append(iReligion)
	
	if gc.getPlayer(iPlayer).isAlive():
		statsList.append(getConquestVictoryScore(iPlayer, iVictory))
		statsList.append(getDominationVictoryScore(iPlayer, iVictory))
		statsList.append(getSpaceVictoryScore(iPlayer, iVictory))
		statsList.append(getDiploVictoryScore(iPlayer, iVictory))
		statsList.append(getCultureVictoryScore(iPlayer, iVictory))
	else:
		statsList.append(0)
		statsList.append(0)
		statsList.append(0)
		statsList.append(0)
		statsList.append(0)	
	return statsList
	
def getConquestVictoryScore(iPlayer, iVictory):
	iTeam = gc.getPlayer(iPlayer).getTeam()
		
	if CyGame().getWinner() == iTeam and (iVictory == gc.getInfoTypeForString("VICTORY_CONQUEST")):
		if CyGame().getGameTurn() == 0:
			fTurnRatio = CyGame().getEstimateEndTurn()
		else:
			fTurnRatio =  float(CyGame().getEstimateEndTurn()) / float(CyGame().getGameTurn())
			
		iVictoryScore = int(1000 * fTurnRatio)
	else:
		fPlayersRatio = CyGame().countCivPlayersAlive() / CyGame().countCivPlayersEverAlive()
		
		iVictoryScore = int(1000 / (1 + fPlayersRatio))
		
		iTotalPower = 0
		for i in range(gc.getMAX_CIV_TEAMS()):
			if gc.getTeam(i).isAlive() and not gc.getTeam(i).isBarbarian():
				iTotalPower += gc.getTeam(i).getPower()
				
		fPowerRatio = float(gc.getTeam(iTeam).getPower()) / float(iTotalPower)

		
		iVictoryScore = int(iVictoryScore * fPowerRatio)
	
	return iVictoryScore

	
def getDominationVictoryScore(iPlayer, iVictory):
	iTeam = gc.getPlayer(iPlayer).getTeam()
	
	if (CyGame().getWinner() == iTeam) and (iVictory == gc.getInfoTypeForString("VICTORY_DOMINATION")):
		if CyGame().getGameTurn() == 0:
			fTurnRatio = CyGame().getEstimateEndTurn()
		else:
			fTurnRatio =  float(CyGame().getEstimateEndTurn()) / float(CyGame().getGameTurn())
			
		iVictoryScore = int(1000 * fTurnRatio)
	else:
		totalLand = gc.getMap().getLandPlots()
		ourLand = gc.getTeam(iTeam).getTotalLand()
		if (totalLand > 0):
			landPercent = (ourLand * 100) / totalLand
		else:
			landPercent = 0
			
		fLandVictoryRatio = float(landPercent) / max(1, float(gc.getGame().getAdjustedLandPercent(gc.getInfoTypeForString("VICTORY_DOMINATION"))))
		
		totalPop = CyGame().getTotalPopulation()
		ourPop = gc.getTeam(iTeam).getTotalPopulation()
		if (totalPop > 0):
			popPercent = (ourPop * 100.0) / totalPop
		else:
			popPercent = 0.0
			
		fPopVictoryRatio = float(popPercent) / max(1,float(gc.getGame().getAdjustedPopulationPercent(gc.getInfoTypeForString("VICTORY_DOMINATION"))))
		
		iVictoryScore = int(1000 * (fLandVictoryRatio * fPopVictoryRatio))
		
	return iVictoryScore
			
def getSpaceVictoryScore(iPlayer, iVictory):
	iTeam = gc.getPlayer(iPlayer).getTeam()
	
	if CyGame().getWinner() == iTeam and iVictory == gc.getInfoTypeForString("VICTORY_SPACE_RACE"):
		if CyGame().getGameTurn() == 0:
			fTurnRatio = CyGame().getEstimateEndTurn()
		else:
			fTurnRatio =  float(CyGame().getEstimateEndTurn()) / float(CyGame().getGameTurn())
			
		iVictoryScore = int(1000 * fTurnRatio)
	
	else:
		iNumShipPartsNeeded = 0
		iNumOurShipParts = 0
		for i in range(gc.getNumProjectInfos()):
			iTmpNumNeeded = gc.getBuildingClassInfo(i).getVictoryThreshold(gc.getInfoTypeForString("VICTORY_SPACE_RACE"))
			if iTmpNumNeeded > 0:
				iNumShipPartsNeeded += iTmpNumNeeded
				iNumShipParts += gc.getTeam(iTeam).getBuildingClassCount(i)

		if iNumOurShipParts > 0:
			fShipPartRatio = float(iNumShipPartsNeeded) / float(iNumOurShipParts)
		else:
			fShipPartRatio = 0
		
		iVictoryScore = int(1000 * fShipPartRatio)
		
	return iVictoryScore
			
def getDiploVictoryScore(iPlayer, iVictory):
	iTeam = gc.getPlayer(iPlayer).getTeam()
	
	if CyGame().getWinner() == iTeam and iVictory == gc.getInfoTypeForString("VICTORY_DIPLOMATIC"):
		if CyGame().getGameTurn() == 0:
			fTurnRatio = CyGame().getEstimateEndTurn()
		else:
			fTurnRatio =  float(CyGame().getEstimateEndTurn()) / float(CyGame().getGameTurn())
			
		iVictoryScore = int(1000 * fTurnRatio)
	else:
		iVictoryScore = 0
			
	return iVictoryScore
			
def getCultureVictoryScore(iPlayer, iVictory):
	iTeam = gc.getPlayer(iPlayer).getTeam()
	
	if CyGame().getWinner() == iTeam and iVictory == gc.getInfoTypeForString("VICTORY_CULTURAL"):
		if CyGame().getGameTurn() == 0:
			fTurnRatio = CyGame().getEstimateEndTurn()
		else:
			fTurnRatio =  float(CyGame().getEstimateEndTurn()) / float(CyGame().getGameTurn())
			
		# The x10 is due to switching methods of recording a near culture victory from all cities to worst (3rd) city.
		iVictoryScore = int(1000 * fTurnRatio) * 10
	else:
		player = PyPlayer(iPlayer)
		if player.isAlive():
			cityList = player.getCityList()
			listCultureCities = len(cityList) * [0]
			i = 0
			for city in cityList:
				listCultureCities[i] = city.getCulture()
				i += 1
			listCultureCities.sort()
			listCultureCities.reverse()
			
		if listCultureCities != []:
			worstCultureCity = listCultureCities[min(len(listCultureCities), gc.getVictoryInfo(gc.getInfoTypeForString("VICTORY_CULTURAL")).getNumCultureCities()) - 1]
			fCultureRatio = min(1, float(worstCultureCity) / float(gc.getCultureLevelInfo(gc.getVictoryInfo(gc.getInfoTypeForString("VICTORY_CULTURAL")).getCityCulture()).getSpeedThreshold(CyGame().getGameSpeedType())))
		else:
			fCultureRatio = 0
		# The x10 is due to switching methods of recording a near culture victory from all cities to worst (3rd) city.
		iVictoryScore = int(1000 * fCultureRatio) * 10
			
	return iVictoryScore
	
def matchAIToLeader(eLeader):
	global tmpAIList
	global gameAIList	
	
	if not tmpAIList:
		return
	
	if len(tmpAIList) == 1:
		bestAI = tmpAIList[0]
		gameAIList.append(bestAI)
		tmpAIList.remove(bestAI)
	else:
		iAIValue = 0
		leaderInfo = gc.getLeaderHeadInfo(eLeader)
		
		statRanks = []
		
		for iStat in range(NUM_STATS):
			statRanks.append([])
			for AI in tmpAIList:
				statRanks[iStat].append(AI.getStat(iStat))
				
			statRanks[iStat].sort()
					
		iBestAIValue = 0
		bestAI = None
				
		for AI in tmpAIList:
			iAIValue = 0
		
			for iStat in range(NUM_STATS):
				iStatWeight = 0
				for statEntry in statRanks[iStat]:
					iStatWeight += 1
					if statEntry == AI.getStat(iStat):
						break
									
				if iStat == STAT_ECONOMY:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_GOLD)
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_SCIENCE)
					
				elif iStat == STAT_INDUSTRY:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_PRODUCTION)
				
				elif iStat == STAT_AGRICULTURE:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_GROWTH)
				
				elif iStat == STAT_MILITARY:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_MILITARY)
				
				elif iStat == STAT_LANDAREA:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_GROWTH)
				
				elif iStat == STAT_POPULATION:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_GROWTH)
				
				elif iStat == STAT_CULTURE:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_CULTURE)
				
				elif iStat == STAT_RELIGION:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_RELIGION)
				
				elif iStat == STAT_VICTORY_CONQUEST:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_MILITARY)
				
				elif iStat == STAT_VICTORY_DOMINATION:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_MILITARY)
				
				elif iStat == STAT_VICTORY_SPACE:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_SCIENCE)
				
				elif iStat == STAT_VICTORY_DIPLO:
					pass
				
				elif iStat == STAT_VICTORY_CULTURE:
					iAIValue += iStatWeight * leaderInfo.getFlavorValue(FLAVOR_CULTURE)

			iAIValue *= 80 + CyGame().getSorenRandNum(41, "AIValue % fudge")
					
			if iAIValue > iBestAIValue:
				iBestAIValue = iAIValue
				bestAI = AI 
				
		tmpAIList.remove(bestAI)
		gameAIList.append(bestAI)

	


def addFinishedPopup():
	popupInfo = CyPopupInfo()
	popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_TEXT)
	popupInfo.setText("""
AI Testing complete. Please either upload at CFC, or email me (The_Great_Apple@hotmail.com) the files:
	AIData.txt
	DeadAIData.txt
The files should be in your My Documents/My Games/SMC4/GeneticAI directory.

Thanks for your help! I hope you'll try another set of AIs.""")
	popupInfo.addPopup(0) 
	
	
# SAVE / LOAD Compatablity:
def onPreSave(argsList):	

	saveString = ""

	for AI in gameAIList:
		saveString += str(AI.getAIData())
		saveString += "\n"
		
	CyGame().setScriptData(saveString)
	
def onLoad(argsList):
	global gameAIList
	global iNumGamePlayers
	
	saveString = CyGame().getScriptData().split("\n")
	
	for data in saveString:
		for AI in AIStore.getAIList():
			if str(AI.getAIData()) == data:
				gameAIList.append(AI)
				AIStore.AIList.remove(AI)
				break
				
	iNumGamePlayers = len(gameAIList)
	
	for iPlayer in range(iNumGamePlayers):
		gc.getPlayer(iPlayer).setName(gameAIList[iPlayer].getAIName())